Name: mailfront-plugin-check-helo
Summary: A mailfront plugin to provide an ability to reject, defer or add it's helo name checking results to message header
Version: 0.04
Release: 1%{?dist}
License: GPL
Group: Utilities/System
Source: http://choon.net/opensource/mailfront-plugin-check-helo-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: gcc >= 3.4.6, make, bglibs-devel >= 1.104, mailfront-devel >= 1.12
Requires: bglibs >= 1.104, mailfront >= 1.12, ucspi-tcp >= 0.88
URL: http://choon.net/mailfront-plugin-check-helo.php

%description
Plugin: check-helo

This plugin provides an ability to reject, defer or add it's helo name
checking results to message header.

Reference:
http://www.linuxmagic.com/best_practices/valid_helo_domain.html

IMPORTANT: This plugin is written for and tested with mailfront 2.00
(might work with earlier version).

* If $RELAYCLIENT or $HELO_CHECK_SKIP is set, this plugin will be skipped.
* If sender is authenticated, this plugin will be skipped also.
* If $HELO_CHECK_REJECT is set, sender will be rejected with reply code 554.
* If $HELO_CHECK_DEFER is set, sender will be deferred with reply code 421.
* NOTE: $HELO_CHECK_REJECT take preference of $HELO_CHECK_DEFER.
* If $HELO_CHECK_REMOTEHOST is set, this plugin will check helo name and
  remotehost whether both are the same otherwise add headers or defer or
  reject accordingly.
* If $HELO_CHECK_REMOTEIP is set, this plugin will check helo name A records
  and remoteip whether both are the same otherwise add headers or defer or
  reject accordingly.  If both are the same, add headers and skip the rest
  of the checks.
* If $HELO_CHECK_REMOTEIP_MATCH is set, this plugin will check the first 3
  octets of remoteip against helo name A records.  If there isn't a match, add
  headers or defer or reject accordingly.  If there is, add headers and skip
  the rest of the checks.
* If $HELO_CHECK_PTR is set, this plugin will make sure the PTR record
  resolves to the same given helo name.  If this is not set, this plugin will
  only check for PTR record of the given helo name's IP exists.
* If $HELO_CHECK_VERBOSE is set, this plugin will log its checking to stderr.
* If all the mentioned variables not set and sender is not authenticated, this
  plugin will add it's helo name checking in each message header.


%prep
%setup -q
# conf-bgincs default is /usr/local/bglibs/include
# conf-bglibs default is /usr/local/bglibs/lib
# conf-ld default is gcc -s -L/usr/local/lib
echo "gcc -Wall -O2 -s -rdynamic" >conf-ld
# conf-mailfrontincs default is /usr/local/include/mailfront
echo %{_includedir}/mailfront > conf-mailfrontincs
# conf-modules default is /usr/local/lib/mailfront
echo %{_libdir}/mailfront > conf-modules
#echo "gcc %{optflags}" >conf-cc
# conf-ccso default is gcc -W -Wall -Wshadow -O -g -I/usr/local/include -fPIC -shared
#echo "gcc %{optflags} -fPIC -shared" >conf-ccso
#echo %{_bindir} >conf-bin
#echo %{_libdir}/mailfront >conf-modules
#echo %{_includedir} >conf-include

%build
make

%install
rm -fr %{buildroot}
mkdir -p %{buildroot}/%{_libdir}/mailfront
install -m0755 plugin-check-helo.so %{buildroot}/%{_libdir}/mailfront/
#make install_prefix=%{buildroot} install

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README COPYING CHANGES plugin-check-helo.html
#%{_bindir}/*
%{_libdir}/mailfront/plugin-check-helo.so

%changelog

* Fri May 31 2013 Giam Teck Choon <choonrpms@choon.net> - 0.04-1
- Fix typo in resp.number to 421 instead of 451 if $HELO_CHECK_DEFER is set
- Change return value in check_hostname function to actual ret value instead
  of 0
- If ret == EAI_MEMORY return Out of Memory error in response in function
  response *sender besides int outofmemory greater than 0
- If resp.number is greater than 0 and ret == EAI_NONAME, defer or reject
  accordingly in function response *sender otherwise defer the mail for
  for remote MTA to retry later as failsafe

* Thu May 30 2013 Giam Teck Choon <choonrpms@choon.net> - 0.03-1
- Update plugin-check-helo.html
- Update README
- Add match_ipv4 function, implement $HELO_CHECK_REMOTEIP and
  $HELO_CHECK_REMOTEIP_MATCH
- Add init_HostDNSIP function, redo struct HostDNSIP and free_HostDNSIP
  function
- Remove a space
- Implement support environment variable $HELO_CHECK_VERBOSE

* Sat May 25 2013 Giam Teck Choon <choonrpms@choon.net> - 0.02-1
- Add define macro MAX_DNSIP_RECORDS default to 10 if not define and update
  function check_hostname to have this limit

* Fri May 24 2013 Giam Teck Choon <choonrpms@choon.net> - 0.01-1
- Initial Release
